#ifndef GRID3D
#define GRID3D

#include <vector>
using namespace std;
/********************************************
  This class is a plain nxnxn array
  without any further structure

  Programmed by Luis Silvestre Feb-2007
********************************************/

class grid3d{
    vector<double> m;
    int n;
  public:
    // Constructors and destructors
    grid3d(int dim=2);
    grid3d(const grid3d& g);
    ~grid3d();
    
    // Accessors
    double & at(int i, int j, int k);
    double & operator() (int i, int j, int k);
    double get(int i, int j, int k) const;
    const vector<double> vector() const {return m;};
    
    // Misc functions
    int dimension() const {return n;};
    int size() const {return m.size();};     // returns n*n*n
    void clear();                            // Makes it all zero
    double norm() const;                     // returns the maximum absolute value of all elements
    double norm2() const;                    // returns the L^2 norm squared;
    grid3d interpolate(int m);               // Interpolates the grid to an mxmxm one
    
    // Operators
    grid3d & operator=(const grid3d &);
    grid3d & operator+=(const grid3d &);
    grid3d & operator-=(const grid3d &);
    grid3d operator+(const grid3d &) const;  // adds componentwise
    grid3d operator-(const grid3d &) const;  // subtracts componentwise
    double operator*(const grid3d &) const;  // takes inner product
    
    friend grid3d operator*(double, const grid3d &);
};

grid3d operator*(double, const grid3d &);    // Multiplication times a scalar
#endif
